//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymEditDlgs.h"
#include "NymWizDlgs.h"
#include "NymRemsDlgs.h"
#include "NymRepDlgs.h"
#include "NymMail.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TNymEditDlg *NymEditDlg;
//---------------------------------------------------------------------------
bool __fastcall EditNymCommands(TForm *Owner, TStrings *nymcmds)
{
   bool save = false;
   NymEditDlg = new TNymEditDlg(Owner,0);
   NymEditDlg->Memo1->Lines->Text = nymcmds->Text;
   NymEditDlg->Memo1->Modified = false;
   NymEditDlg->ShowModal();
   if (NymEditDlg->ModalResult==mrOk && NymEditDlg->Memo1->Modified)
   {
      nymcmds->Text = NymEditDlg->Memo1->Lines->Text;
      int i=0; while(i<nymcmds->Count)
      {
         if (nymcmds->Strings[i].Trim().IsEmpty()) nymcmds->Delete(i);
         else i++;
      }
      for (i=0; i<nymcmds->Count; i++)
      {
         AnsiString line = nymcmds->Strings[i];
         if (line[1]!='+' && line[1]!='-') nymcmds->Strings[i] = "-"+line;
      }
      save = true;
   }
   delete NymEditDlg;
   return save;
}
//---------------------------------------------------------------------------
bool __fastcall EditNymServers(TForm *Owner, TStrings *Servers)
{
   bool save = false;
   NymEditDlg = new TNymEditDlg(Owner,0);
   NymEditDlg->Caption = "Available Nymservers -- enter domain portion of server address";
   NymEditDlg->Memo1->Lines->Text = Servers->Text;
   NymEditDlg->Memo1->Modified = false;
   NymEditDlg->ShowModal();
   if (NymEditDlg->ModalResult==mrOk && NymEditDlg->Memo1->Modified)
   {
      Servers->Text = NymEditDlg->Memo1->Lines->Text;
      save = true;
   }
   delete NymEditDlg;
   return save;
}
//---------------------------------------------------------------------------
bool __fastcall EditReplyBlocks(TForm *Owner, TStrings *replyblks)
{
   bool save = false;
   NymEditDlg = new TNymEditDlg(Owner,Screen->Height-83);
   NymEditDlg->Top = (Screen->Height-NymEditDlg->Height)/2;
   //if (NymEditDlg->Top<5) NymEditDlg->Top = 5;
   NymEditDlg->Caption = "Reply Blocks";
   NymEditDlg->Panel3->Visible = true;
   NymEditDlg->LoadCpkDirectivesMenu();
   NymEditDlg->LoadCpkHeadersMenu();
   NymEditDlg->LoadRBTemplatesMenu();
   NymEditDlg->LoadRemailersMenu();
   //NymEditDlg->Label3->Visible = false;
   NymEditDlg->Label1->Visible = true;
   NymEditDlg->Label1->Caption = "";
   NymEditDlg->Label2->Visible = true;
   NymEditDlg->Label2->Caption = "";
   NymEditDlg->Panel1->Height = 74;
   NymEditDlg->Memo1->Lines->Text = replyblks->Text;
   NymEditDlg->Memo1->Modified = false;
   Application->OnHint = NymEditDlg->ShowHint;
   NymEditDlg->ShowModal();
   if (NymEditDlg->ModalResult==mrOk && NymEditDlg->Memo1->Modified)
   {
      replyblks->Text = NymEditDlg->Memo1->Lines->Text;
      save = true;
   }
   delete NymEditDlg;
   return save;
}
//---------------------------------------------------------------------------
bool __fastcall EditCpkDirectives(TForm *Owner, TStrings *directs)
{
   bool save = false;
   NymEditDlg = new TNymEditDlg(Owner,0);
   NymEditDlg->Caption = "Cyberpunk Remailer Directives";
   //NymEditDlg->Label3->Visible = false;
   NymEditDlg->Memo1->Lines->Text = directs->Text;
   NymEditDlg->Memo1->Modified = false;
   NymEditDlg->ShowModal();
   if (NymEditDlg->ModalResult==mrOk && NymEditDlg->Memo1->Modified)
   {
      directs->Text = NymEditDlg->Memo1->Lines->Text;
      for (int i=0; i<directs->Count; i++)
         directs->Strings[i] = directs->Strings[i].Trim();
      save = true;
   }
   delete NymEditDlg;
   return save;
}
//---------------------------------------------------------------------------
bool __fastcall EditCpkHeaders(TForm *Owner, TStrings *headers)
{
   bool save = false;
   NymEditDlg = new TNymEditDlg(Owner,0);
   NymEditDlg->Caption = "Cyberpunk Remailer Headers";
   //NymEditDlg->Label3->Visible = false;
   NymEditDlg->Memo1->Lines->Text = headers->Text;
   NymEditDlg->Memo1->Modified = false;
   NymEditDlg->ShowModal();
   if (NymEditDlg->ModalResult==mrOk && NymEditDlg->Memo1->Modified)
   {
      headers->Text = NymEditDlg->Memo1->Lines->Text;
      for (int i=0; i<headers->Count; i++)
         headers->Strings[i] = headers->Strings[i].Trim();
      save = true;
   }
   delete NymEditDlg;
   return save;
}
//---------------------------------------------------------------------------
bool __fastcall EditRBTemplates(TForm *Owner, TStrings *temps)
{
   bool save = false;
   NymEditDlg = new TNymEditDlg(Owner,0);
   NymEditDlg->Height = Screen->Height-83;
   NymEditDlg->Top = (Screen->Height-NymEditDlg->Height)/2;

   NymEditDlg->Caption = "Reply Block Templates";
   //NymEditDlg->Label3->Visible = false;
   NymEditDlg->Memo1->Lines->Text = temps->Text;
   NymEditDlg->Memo1->Modified = false;
   //NymEditDlg->BigBtn->Visible = true;
   NymEditDlg->ShowModal();
   if (NymEditDlg->ModalResult==mrOk && NymEditDlg->Memo1->Modified)
   {
      temps->Text = NymEditDlg->Memo1->Lines->Text;
      save = true;
   }
   delete NymEditDlg;
   return save;
}
//---------------------------------------------------------------------------
__fastcall TNymEditDlg::TNymEditDlg(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
}
//---------------------------------------------------------------------------
__fastcall TNymEditDlg::TNymEditDlg(TComponent* Owner, int height)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   if (height)
   {
      Height = height;
      if (height>Screen->Height) Height = Screen->Height-50;
      int space = Screen->Height-Height;
      Top = space/2;// - 40;
      if (Top<10) Top = 10;
      if (Top+Height>Screen->Height) Top = 10;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && Memo1->Modified)
   {
      switch (MsgBoxHwnd(Handle,
         "Your nym commands are modified!\n\nSave your changes?",
         "Confirm",MB_YESNOCANCEL))
      {
         case ID_CANCEL: CanClose = false; return;
         case ID_YES: ModalResult = mrOk; break;
      }
   }
   if (ModalResult==mrOk && !Memo1->Modified)
       ModalResult= mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::ShowHint(TObject *Sender)
{
   Label2->Caption = GetToken(0,Application->Hint.c_str(),"|");
   Label1->Caption = GetToken(1,Application->Hint.c_str(),"|");
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::BigBtnClick(TObject *Sender)
{
   if (BigBtn->Caption=="Bigger")
   {
      BigBtn->Enabled = false;
      Height = Screen->Height-83;
      Top = (Screen->Height-Height)/2;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::TemplateBtnClick(TObject *Sender)
{
   /*TPoint P,Q;
   P.x = TemplateBtn->Left+1;;
   P.y = TemplateBtn->Top+TemplateBtn->Height-1;
   Q = ClientToScreen(P);
   PopupTmpMenu->Popup(Q.x,Q.y);*/
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::DirectBtnClick(TObject *Sender)
{
   /*TPoint P,Q;
   P.x = DirectBtn->Left+1;
   P.y = DirectBtn->Top+DirectBtn->Height-1;
   Q = ClientToScreen(P);
   PopupDirMenu->Popup(Q.x,Q.y);*/
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::RemailerBtnClick(TObject *Sender)
{
   /*AnsiString addr = GetRemailerAddress(this);
   if (!addr.IsEmpty()) Memo1->SelText = addr;
   ActiveControl = Memo1;*/
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::PopupMenuItemOnClick(TObject *Sender)
{
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))==NULL) return;
   AnsiString dir = item->Caption;
   if (dir.Length() && dir[dir.Length()]==':') dir += " ";
   else dir += "\r\n";
   Memo1->SelText = dir;
   ActiveControl = Memo1;
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::PopupRBTempItemOnClick(TObject *Sender)
{
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))==NULL) return;
   Memo1->Clear(); AppProcessMessages();
   SetRedraw(Memo1,0); Sleep(200);

   bool saving = false;
   TStrings *rb = Memo1->Lines;
   AnsiString line,name = item->Caption;
   TStringList *temps = new TStringList();
   GetAppData(temps,NymRBTempsKey);
   for (int i=0; i<temps->Count; i++)
   {
      line = temps->Strings[i];
      if (line=="["+name+"]")
      {
         saving = true;
         continue;
      }
      if (saving && line.Pos("[")==1) break;
      if (saving) rb->Add(line);
   }
   while (rb->Count && rb->Strings[0].Trim().IsEmpty()) rb->Delete(0);
   while (rb->Count && rb->Strings[rb->Count-1].Trim().IsEmpty())
      rb->Delete(rb->Count-1);
   ActiveControl = Memo1;
   Memo1->SelStart = 0;
   AppProcessMessages();
   SetRedraw(Memo1,1);
   delete temps;
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::LoadRemailersMenu()
{
   while (PopupRemMenu->Items->Count>0)
      PopupRemMenu->Items->Delete(PopupRemMenu->Items->Count-1);
   // list of remailer caps strings in form shortname=caps string
   AnsiString shrt,addr,line,caps,cap;
   TStringList *remcaps,*remperf,*rems,*tmp;
   tmp = new TStringList();
   rems = new TStringList();
   remcaps = new TStringList();
   remperf = new TStringList();
   if (FileExists(clisttxt)) tmp->LoadFromFile(clisttxt);
   for (int i=0; i<tmp->Count; i++)
   {
      line = tmp->Strings[i];
      if (line.Pos("$remailer{")==1)
      {
         shrt = GetToken(1,line,"\"");
         caps = GetToken(3,line,"\"");
         remcaps->Add(shrt+"="+GetToken(1,caps,">").Trim());
      }
      else
      if (line.Pos("%")==line.Length())
      {
         shrt = GetToken(0,line," ");
         addr = GetParamSpc(1,line);
         remperf->Add(shrt+"="+addr+"\r\nrecent history: "+line.SubString(line.Length()-29,30));
         rems->Add(shrt);
      }
   }
   for (int i=0; i<rems->Count; i++)
   {
      shrt = rems->Strings[i];
      cap = shrt+"\t"+remperf->Values[shrt];
      if (shrt.Trim().IsEmpty()) continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupMenuItemOnClick;
      item->Caption = shrt; //cap;
      item->Hint = remperf->Values[shrt]+"|"+remcaps->Values[shrt];
      PopupRemMenu->Items->Add(item);
      //if (i==rems->Count/2) item->Break = mbBarBreak;
   }
   delete remperf;
   delete remcaps;
   delete rems;
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::LoadCpkDirectivesMenu()
{
   TStringList *dirs = new TStringList();
   while (PopupDirMenu->Items->Count>2)
      PopupDirMenu->Items->Delete(PopupDirMenu->Items->Count-1);
   GetCpkDirectives(dirs);
   for (int i=0; i<dirs->Count; i++)
   {
      if (dirs->Strings[i].Trim().IsEmpty()) continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupMenuItemOnClick;
      item->Caption = dirs->Strings[i].Trim();
      PopupDirMenu->Items->Add(item);
   }
   delete dirs;
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::LoadCpkHeadersMenu()
{
   TStringList *hdrs = new TStringList();
   while (PopupHdrMenu->Items->Count>2)
      PopupHdrMenu->Items->Delete(PopupHdrMenu->Items->Count-1);
   GetCpkHeaders(hdrs);
   for (int i=0; i<hdrs->Count; i++)
   {
      if (hdrs->Strings[i].Trim().IsEmpty()) continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupMenuItemOnClick;
      item->Caption = hdrs->Strings[i].Trim();
      PopupHdrMenu->Items->Add(item);
   }
   delete hdrs;
}
//---------------------------------------------------------------------------
void __fastcall TNymEditDlg::LoadRBTemplatesMenu()
{
   AnsiString line;
   TStringList *tmps = new TStringList();
   while (PopupTmpMenu->Items->Count>2)
      PopupTmpMenu->Items->Delete(PopupTmpMenu->Items->Count-1);
   GetAppData(tmps,NymRBTempsKey);
   for (int i=0; i<tmps->Count; i++)
   {
      line = tmps->Strings[i];
      if (line.IsEmpty() || line[1]!='[') continue;
      TMenuItem *item = new TMenuItem(this);
      item->OnClick = PopupRBTempItemOnClick;
      item->Caption = line.SubString(2,line.Length()-2);
      PopupTmpMenu->Items->Add(item);
   }
   delete tmps;
}
//---------------------------------------------------------------------------